/*
 * Copyright (C) 2014, 2015, Mateusz Viste
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef GRAPH_H_SENTINEL
  #define GRAPH_H_SENTINEL

  enum ui_events_t {
    Event_NONE = 0,
    Event_CLICK = 1,
    Event_SWEEP = 2,
    Event_SCROLL = 3,
    Event_CURSORMOVE = 4,
    Event_UNKNOWN = 254,
    Event_QUIT = 255
  };

  enum ui_gamemode_t {
    GAMEMODE_AI,
    GAMEMODE_NET,
    GAMEMODE_QUIT
  };

  int ui_setparams(int x, int y, int tkratkaSize, int tkratkaThickness, int tkratkaKolor, int tplayer1color, int tplayer2color, int tkartkaBackgroundColor, int twallThickness, int tkropkaRadius);
  void graph_drawscores(int p1, int p2);
  void ui_drawKartka(int width, int height, int *scrollvector);
  void graph_drawKropka(int x, int y, int player, int activeflag, int *scrollvector);
  void graph_drawWall(int x1, int y1, int x2, int y2, int player, int *scrollvector);
  void graph_free(void);
  void graph_mousemap(int mx, int my, int *dotx, int *doty, int *scrollvector);
  void graph_refresh(void);
  void ui_drawscores(int *scores, char *msg);
  enum ui_events_t ui_getevent(int *x, int *y, int *z, int nofilter);
  long ui_getticks(void);
  enum ui_gamemode_t ui_selectgamemode(void);
  void ui_applyfaderect(int size);
  void ui_throwmsg(char *msg);
  void ui_delay(int ms);
#endif
